#ifndef I0mapmon_H
#define I0mapmon_H

#include <QWidget>

// cumbia
#include <qulogimpl.h>
#include <cucontrolsfactorypool.h>
class CumbiaPool;
class CuData;
// cumbia

class CheckableComboBoxModel;

namespace Ui {
class I0mapmon;
}

class I0mapmon : public QWidget
{
    Q_OBJECT

public:
    explicit I0mapmon(CumbiaPool *cu_p, QWidget *parent = 0);
    ~I0mapmon();

private slots:
    void onLabelReady(const QStringList& n);
    void applyWavelenX();
    void onYChanged(const QString& y);
    void onWlensChanged(const CuData &s);
    void onWlenSelectionChanged(const QString &wl, bool enab);
    void setYMinMax();

    void m_plot_reconf();

private:
    Ui::I0mapmon *ui;

    // cumbia
    CumbiaPool *cu_pool;
    QuLogImpl m_log_impl;
    CuControlsFactoryPool m_ctrl_factory_pool;
    // cumbia

    int m_fel0x;

    CheckableComboBoxModel* m_cb_model;

    // methods
    void m_setup_x_list();

    QMap<int, double> m_selected_wlens() const;
    QStringList m_ynames;
};

#endif // I0mapmon_H
