#ifndef I0MMONPLOT_H
#define I0MMONPLOT_H

#include <cucontrolsfactorypool.h>
#include <quplot_base.h>
#include <cudata.h>
#include <qwt_symbol.h>
#include <QString>
#include <QMap>

class CumbiaPool;
class QuMultiReaderPluginInterface;

class I0MMonPlot : public QuPlotBase
{
    Q_OBJECT
public:
    explicit I0MMonPlot(QWidget *parent, CumbiaPool *cup, const CuControlsFactoryPool & fpoo);
    ~I0MMonPlot();

    bool pluginLoaded() const;

    bool yAutoScale() const;

signals:

public slots:
    void onDataReady(const QList<CuData> & dl);
    void setSources(const QString& x, const QString& y, const QMap<int, double> lambdamap, int nsamples);
    void setYBounds(double ymi, double yma);
    void setYBoundsAuto(bool a);
    void setYLogScale(bool a);

private:

    void m_set_bounds(const QVector<double> &xv, const QVector<double> &yv);
    void m_reset_scales();
    void m_curves_style();

    CumbiaPool *m_cu_poo;
    CuControlsFactoryPool m_ctrl_fpool;
    QuMultiReaderPluginInterface *m_multiread_plu_i;

    int m_numsamples;
    QMap<int, double> m_lambdas;
    QMap<QString, QwtSymbol::Style> m_curvesymap;

    const QList<QwtSymbol::Style> m_symstyles;

    bool m_time_mode, m_empty, m_log_scale;

    double m_ymin, m_ymax;
    QList<QColor> m_colormap;
};

#endif // I0MMONPLOT_H
